'\" t
.\"	cook - a file construction tool
.\"	Copyright (C) 1992, 1993, 1994, 1995 Peter Miller;
.\"	All rights reserved.
.\"
.\"	This program is free software; you can redistribute it and/or modify
.\"	it under the terms of the GNU General Public License as published by
.\"	the Free Software Foundation; either version 2 of the License, or
.\"	(at your option) any later version.
.\"
.\"	This program is distributed in the hope that it will be useful,
.\"	but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"	GNU General Public License for more details.
.\"
.\"	You should have received a copy of the GNU General Public License
.\"	along with this program; if not, write to the Free Software
.\"	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.\" MANIFEST: source of the README file
.\"
.TH readme cook
.so ../doc/version.so
.hy 0
.ad l
.SH NAME
cook \- a file construction tool
.SH DESCRIPTION
Put simply,
the
.I cook
program is yet another make-oid.
.PP
The
.I cook
program is a tool for constructing files.
It is given a set of files to create,
and recipes of how to create them.
In any non-trivial program there will be
prerequisites to performing the actions necessary to
creating any file,
such as include files.
The
.I cook
program provides a mechanism to define these.
.PP
When a program is being developed or maintained,
the programmer will typically change one file of several which
comprise the program.
The
.I cook
program examines the last-modified times of the files
to see when the prerequisites of a file have changed,
implying that the file needs to be recreated as it is logically out of date.
.PP
The
.I cook
program also provides a facility for implicit recipes,
allowing users to specify how to form a file with a
given suffix from a file with a different suffix.
For example,
to create
.IR filename .o
from
.IR filename .c
.br
.ne 1i
.SH NEW IN THIS RELEASE
A number of features have been added to
.I cook
with this release.
A few of them are detailed here:
.so new.so
.PP
Plus the usual crop of bug fixes and tinkering.
For excruciating detail,
and also acknowlegements of those who generously sent me feedback,
please see the
.I aux/CHANGES.\*(v)
file included in this distribution.
.br
.ne 1i
.SH HISTORY
The
.I cook
program was originally developed (starting in 1988)
because I was marooned on an operating system without
anything even vaguely resembling make(1).
Since I had to write my own,
I added a few improvements.
When I finally escaped back to UNIX,
it took only two days to port
.I cook
to SystemV.
I have since deleted all code for that original operating system,
although clues to its identity are still present.
There is no prize for guessing what it was.
.PP
After I had
.I cook
up on UNIX,
the progress the world had made caught up with me.
It was gratifying that many of the
features other make-oid authors had thought necessary were
either already present,
or easily and seamlessly added.
.br
.ne 1i
.SH ARCHIVE SITE
The latest version of
.I cook
is available by anonymous ftp from:
.RS 4m
.TS
tab(;);
l l s
l l l.
Host:;ftp.cse.nau.edu (134.114.64.70)
Dir:;/pub/Aegis
File:;README;# what is in this directory
File:;cook.\*(v).tar.gz;# the complete source
File:;cook.\*(v).patch.gz;# patch to take \*(w) to \*(v)
File:;cook.\*(v).ps.gz;# PostScript of the Manual
.TE
.RE
.PP
To use anonymous ftp,
give "anonymous" as the user name (omit the quotes)
and your email address as the password.
.PP
My grateful thanks to Paul Balyoz <pab@ftp.cse.nau.edu>
for his generosity in providing this archive space.
.PP
This directory also contains a few other pieces of software written by me.
Please have a look if you are interested.
.PP
For those of you without ftp,
I recommend the use of an ftp-by-email server.
Here is a list of a few (there are many more):
.RS
.nf
ftpmail@decwrl.dec.com
ftpmail@cs.uow.edu.au
.fi
.RE
.PP
In general, you can get a help message about how to use each system
by sending email with a subject of "help"
and a message body containing just the word "help".
.br
.ne 1i
.SH MAILING LIST
A mailing list has been created so that users of
.I cook
may exchange ideas about how to use the
.I cook
program.
Discussion may include,
but is not limited to:
bugs, enhancements, and applications.
The list is not moderated.
.PP
The address of the mailing list is
.RS
.ft CW
cook-users@bmr.gov.au
.ft R
.RE
.PP
To subscribe to this mailing list,
send an email message to \f(CWmajordomo@bmr.gov.au\fP with
a message body containing the single line
.RS
.ft CW
subscribe cook-users
.ft R
.RE
Please note that \f(CWbmr.gov.au\fP is an Internet site,
so if you have an address which is not readily derived from
your mail headers (majordomo is only a Perl program, after all)
you will need to use a message of the form:
.RS
.ft CW
subscribe cook-users \fIaddress\fP
.ft R
.RE
where \fIaddress\fP is an email address which
makes sense from an Internet site.
.PP
The software which handles this mailing list
.if n CANNOT
.if t .B cannot
send you a copy of the
.I cook
program.
Please use ftp or ftp-by-email, instead.
.br
.ne 1i
.SH BUILDING COOK
Full instructions for building the
.I cook
program may be found in the
.I BUILDING
file included in this distribution.
.br
.ne 1i
.SH COPYRIGHT
.I cook
version \*(v)
.br
Copyright
.if t \(co
.if n (C)
\*(Y) Peter Miller;
All rights reserved.
.PP
This program is free software;
you can redistribute it
and/or modify it under the terms of the GNU General Public
License as published by the Free Software Foundation;
either version 2 of the License,
or (at your option) any later version.
.PP
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY;
without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.
See the GNU General Public License for more details.
.PP
You should have received a copy of the GNU General Public
License along with this program; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
02139, USA.
.PP
It should be in the
.I LICENSE
file included with this distribution.
.br
.ne 1i
.SH AUTHOR
.TS
tab(;);
l l l.
Peter Miller;UUCP;uunet!munnari!bmr.gov.au!pmiller
\f(CW/\e/\e*\fP;Internet;pmiller@bmr.gov.au
.TE
