/*
 *	cook - file construction tool
 *	Copyright (C) 1994 Peter Miller.
 *	All rights reserved.
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * MANIFEST: interface definition for make2cook/variable.c
 */

#ifndef MAKE2COOK_VARIABLE_H
#define MAKE2COOK_VARIABLE_H

#include <blob.h>
#include <word.h>

void variable_rename _((blob_ty *, blob_list_ty *, wlist *));
void variable_archive _((string_ty *target, string_ty *member));

/* for use by vargram */
int vargram_lex _((void));
void vargram_error _((char *, ...));
void vargram_result _((string_ty *));
string_ty *vargram_lookup _((string_ty *));

#endif /* MAKE2COOK_VARIABLE_H */
