#!/bin/sh
#
#	cook - file construction tool
#	Copyright (C) 1990, 1991, 1992, 1993, 1994 Peter Miller.
#	All rights reserved.
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# MANIFEST: test the "-version" command line option
#
tmp=/tmp/$$
PAGER=cat
export PAGER
umask 022
unset COOK
here=`pwd`
if test $? -ne 0 ; then exit 1; fi

if test "$1" != "" ; then bin="$here/$1/bin"; else bin="$here/bin"; fi

fail()
{
	echo 'FAILED test of the -VERSion command line option' 1>&2
	cd $here
	rm -rf $tmp
	exit 1
}
pass()
{
	cd $here
	rm -rf $tmp
	exit 0
}
trap "fail" 1 2 3 15

mkdir $tmp
cd $tmp

$bin/cook -help > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/cook -vers > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/cook -vers r | cat
if test $? -ne 0 ; then fail; fi

$bin/cook -vers w | cat
if test $? -ne 0 ; then fail; fi

$bin/c_incl -help > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/c_incl -vers > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/c_incl -vers r > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/c_incl -vers w > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/find_libs -help > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/find_libs -vers > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/find_libs -vers r > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/find_libs -vers w > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/cookfp -help > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/cookfp -vers > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/cookfp -vers r > /dev/null
if test $? -ne 0 ; then fail; fi

$bin/cookfp -vers w > /dev/null
if test $? -ne 0 ; then fail; fi

# probably OK
pass
